####################################
# All Rights Reserved
# Copyright (c) 2022-2023 fixyldev
####################################

#language_outdated
scoreboard players reset @a[scores={lastdeathlocation.language=1..22}] lastdeathlocation.language

#update
execute as @a unless score @s lastdeathlocation.update matches 1 run function lastdeathlocation:chat/install
execute as @a unless score @s lastdeathlocation.update matches 1 run scoreboard players set @s lastdeathlocation.update 1

#register
execute as @a unless score @s lastdeathlocation.registered matches 0.. run scoreboard players add #count lastdeathlocation.registered 1
execute as @a unless score @s lastdeathlocation.registered matches 0.. run scoreboard players operation @s lastdeathlocation.registered = #count lastdeathlocation.registered

#doImmediateRespawn
execute unless score #doImmediateRespawn lastdeathlocation.gamerule matches 0..1 store result score #doImmediateRespawn lastdeathlocation.gamerule run gamerule doImmediateRespawn
execute store result score #doImmediateRespawn.check lastdeathlocation.gamerule run gamerule doImmediateRespawn
execute if score #doImmediateRespawn.check lastdeathlocation.gamerule matches 1 run gamerule doImmediateRespawn false

#reducedDebugInfo
execute store result score #reducedDebugInfo lastdeathlocation.gamerule run gamerule reducedDebugInfo

#marker_limit
execute unless entity @e[tag=lastdeathlocation,scores={lastdeathlocation.marker_count.select=0..1}] run scoreboard players set @e[tag=lastdeathlocation] lastdeathlocation.marker_count.select 0
execute as @e[tag=lastdeathlocation,sort=random,limit=1,scores={lastdeathlocation.marker_count.select=0}] run scoreboard players set @s lastdeathlocation.marker_count.select 1
execute as @e[tag=lastdeathlocation,scores={lastdeathlocation.marker_count.select=1}] run function lastdeathlocation:marker_count
execute as @e[tag=lastdeathlocation,sort=random,limit=1,scores={lastdeathlocation.marker_count=10..}] at @s as @a[distance=..10] run function lastdeathlocation:chat/marker_count
execute as @e[tag=lastdeathlocation,sort=random,limit=1,scores={lastdeathlocation.marker_count=10..}] at @s run kill @e[tag=lastdeathlocation,distance=..10]

#marker
execute as @a[scores={lastdeathlocation.death=1..},gamemode=!spectator] at @s run summon minecraft:area_effect_cloud ~ ~1.45 ~ {CustomNameVisible:1b,Duration:6000,Tags:["lastdeathlocation"],CustomName:'{"translate":"deathScreen.title","italic":true}'}
execute as @a[scores={lastdeathlocation.death=1..},gamemode=!spectator] at @s unless score @e[tag=lastdeathlocation,distance=..5,sort=nearest,limit=1] lastdeathlocation.marker matches 0.. run scoreboard players operation @e[tag=lastdeathlocation,distance=..5,sort=nearest,limit=1] lastdeathlocation.marker = @s lastdeathlocation.registered
execute at @e[tag=lastdeathlocation] run particle minecraft:wax_off ~0.3 ~-1.45 ~0.3
execute at @e[tag=lastdeathlocation] run particle minecraft:wax_off ~-0.3 ~-1.45 ~0.3
execute at @e[tag=lastdeathlocation] run particle minecraft:wax_off ~-0.3 ~-1.45 ~-0.3
execute at @e[tag=lastdeathlocation] run particle minecraft:wax_off ~0.3 ~-1.45 ~-0.3
execute at @e[tag=lastdeathlocation] run particle minecraft:wax_off ~0.3 ~0.35 ~0.3
execute at @e[tag=lastdeathlocation] run particle minecraft:wax_off ~-0.3 ~0.35 ~0.3
execute at @e[tag=lastdeathlocation] run particle minecraft:wax_off ~-0.3 ~0.35 ~-0.3
execute at @e[tag=lastdeathlocation] run particle minecraft:wax_off ~0.3 ~0.35 ~-0.3
execute as @e[tag=lastdeathlocation] at @s positioned ~ ~-1.45 ~ if entity @r[distance=..5,gamemode=!spectator] unless entity @r[distance=..5,nbt={Health:0f}] if score @r[distance=..5,gamemode=!spectator] lastdeathlocation.registered = @s lastdeathlocation.marker run particle minecraft:totem_of_undying ~ ~1.8 ~ 0.075 0 0.075 0.1 25
execute as @e[tag=lastdeathlocation] at @s positioned ~ ~-1.45 ~ if entity @r[distance=..5,gamemode=!spectator] unless entity @r[distance=..5,nbt={Health:0f}] if score @r[distance=..5,gamemode=!spectator] lastdeathlocation.registered = @s lastdeathlocation.marker run playsound minecraft:entity.experience_orb.pickup player @a[distance=..20] ~ ~ ~ 1 1 1
execute as @e[tag=lastdeathlocation] at @s positioned ~ ~-1.45 ~ if entity @r[distance=..5,gamemode=!spectator] unless entity @r[distance=..5,nbt={Health:0f}] if score @r[distance=..5,gamemode=!spectator] lastdeathlocation.registered = @s lastdeathlocation.marker run kill @s

#lastdeathlocation.manual
scoreboard players enable @a -deathlocation
execute as @a[scores={-deathlocation=..-1}] run scoreboard players set @s -deathlocation 1
execute as @r[scores={-deathlocation=1..}] run function lastdeathlocation:chat/message

#lastdeathlocation
execute as @a[scores={lastdeathlocation.death=1..,lastdeathlocation.display_message=1}] run function lastdeathlocation:chat/message
execute as @a[scores={lastdeathlocation.death=1..}] run scoreboard players reset @s lastdeathlocation.death

#settings
scoreboard players enable @a -deathsettings
execute as @a[scores={-deathsettings=-2..-1}] run function lastdeathlocation:chat/language
execute as @a[scores={-deathsettings=-2147483644..-3}] run scoreboard players set @s -deathsettings 1
execute as @r[scores={-deathsettings=1..}] run function lastdeathlocation:chat/settings

#empty_lines
execute as @a unless score @s lastdeathlocation.empty_lines matches 0..1 run scoreboard players set @s lastdeathlocation.empty_lines 1
execute as @r[scores={-deathsettings=-2147483648..-2147483647}] run function lastdeathlocation:chat/empty_lines

#display_message
execute as @a unless score @s lastdeathlocation.display_message matches 0..1 run scoreboard players set @s lastdeathlocation.display_message 1
execute as @r[scores={-deathsettings=-2147483646..-2147483645}] run function lastdeathlocation:chat/display_message
